// +---------------------------+
// | Liste des modules chargs |
// +---------------------------+

var AL_Liste_librairie;

if (AL_Liste_librairie!=undefined)
  AL_Liste_librairie[AL_Liste_librairie.length]=new AL_Definir_module_librairie("menu","V2.0");

// +-----------------------------------+

var AL_Menu_mode_seul=0;
var AL_Menu_mode_tout=1;
var AL_Menu_mode_survol=2;
var AL_Menu_mode_sans_icone=4; /* implique mode seul + survol */
var AL_Menu_mode_horizontal=8;
var AL_Menu_mode_interieur=16;

var AL_Menu_arbre=AL_Menu_mode_tout;
var AL_Menu_liste_deroulante=AL_Menu_mode_seul+AL_Menu_mode_survol+
                             AL_Menu_mode_horizontal+AL_Menu_mode_interieur;

function AL_Afficher_item_menu(x,y,Droite)
{
  var Nom_icone=null;
  var Icone_x,Icone_y,Deplacer=false;
  
  if (Droite==null) Droite=false;

  if (this.Nb_items==0)
    Nom_icone=this.Nom_zone+'_v';
  else if (this.Ouvert)
    Nom_icone=this.Nom_zone+'_o';
  else
    Nom_icone=this.Nom_zone+'_f';

  if ((this.Nom_icone_visible==Nom_icone)&&(this.x==x)&&(this.y==y))
    return(true);

  if ((this.Icone)&&
      (this.Nom_icone_visible!=Nom_icone)&&
      (this.Nom_icone_visible!=null))
  {
    if ((!Droite)||(this.Nom_icone_visible!=(this.Nom_zone+'_v')))
      AL_Cacher_zone(this.Nom_icone_visible);
  }

  if ((this.Icone)&&((!Droite)||(Nom_icone!=(this.Nom_zone+'_v'))))
  {
    Icone_y=y+this.offset_y;
    Icone_x=x;
    if (Droite)
    {
      Icone_x+=this.Longueur;
      if (this.Interieur)
        Icone_x-=15;
    }
  }
    
  if ((this.x!=x)||(this.y!=y))
  {
    if ((this.Interieur)||(!this.Icone)||(Droite))
      AL_Deplacer_zone(this.Nom_zone,x,y);
    else
      AL_Deplacer_zone(this.Nom_zone,x+15,y);

    if ((this.Icone)&&((!Droite)||(Nom_icone!=(this.Nom_zone+'_v'))))
    {
      Deplacer=true;
      AL_Deplacer_zone(Nom_icone,Icone_x,Icone_y);
    }

    this.x=x; this.y=y;
  }

  if (this.Nom_icone_visible!=Nom_icone)
  {
    if (this.Nom_icone_visible==null)
      AL_Afficher_zone(this.Nom_zone,0);

    if ((this.Icone)&&((!Droite)||(Nom_icone!=(this.Nom_zone+'_v'))))
    {
      if (!Deplacer)
        AL_Deplacer_zone(Nom_icone,Icone_x,Icone_y);
      AL_Afficher_zone(Nom_icone,1);
    }

    this.Nom_icone_visible=Nom_icone;
  }
  
  return(true);
}

function AL_Effacer_item_menu()
{
  if (this.Nom_icone_visible!=null)
  {
    AL_Cacher_zone(this.Nom_zone);
    if (this.Icone)
      AL_Cacher_zone(this.Nom_icone_visible);
    this.Nom_icone_visible=null;
  }
  
  return(true);
}

function AL_Definir_item_menu(Nom,Repertoire,Mode,Code,Longueur,Hauteur,Intitule,Evt,Icone,Interieur)
{
  this.Code=Code;
  this.Intitule=Intitule;
  this.Longueur=Longueur;
  this.Hauteur=Hauteur;
  this.Icone=Icone;
  this.Interieur=Interieur;
  this.Nb_items=0;
  this.Fils=Array();

  this.Ouvert=false;
  this.Nom_zone='AL_Menu_'+Nom+'_'+Code;

  this.x=0.0001; this.y=0.0001; this.offset_y=(this.Hauteur-15)/2;
  this.Nom_icone_visible=null;

  if (this.Icone)
  {
    AL_Creer_zone(this.Nom_zone+'_o',0,0,10,10,'<a href="javascript:'+Nom+'.Fermer(\''+Code+'\');"><img src="'+Repertoire+'/ouvert.gif" border=0 width=10 height=10></a>',false);
    AL_Creer_zone(this.Nom_zone+'_f',0,0,10,10,'<a href="javascript:'+Nom+'.Ouvrir(\''+Code+'\');"><img src="'+Repertoire+'/ferme.gif" border=0 width=10 height=10></a>',false);
    AL_Creer_zone(this.Nom_zone+'_v',0,0,10,10,'<img src="'+Repertoire+'/fin.gif" border=0 width=10 height=10>',false);
  }

  if (Evt=="onClick")
    AL_Creer_zone(this.Nom_zone,0,0,Longueur,Hauteur,Intitule,false);
  else if (Evt=="onMouseOver")
    AL_Creer_zone(this.Nom_zone,0,0,Longueur,Hauteur,Intitule,false,'javascript:'+Nom+'.Ouvrir(\''+Code+'\');');

  this.Afficher=AL_Afficher_item_menu;
  this.Effacer=AL_Effacer_item_menu;
  
  return(this);
}

function AL_Creer_item_menu(Pere,Code,Longueur,Hauteur,Intitule)
{
  var Item=null;
  var Courant;
  var Nb;
  
  if (this.Rechercher(Code)!=null)
    return(false);
  
  if (Hauteur<15)
    Hauteur=15;
    
  if ((this.Interieur)&&(Longueur<15))
    Longueur=15;
  
  if (Pere==null) 
    Item=this.Item;
  else
  {
    Courant=this.Rechercher(Pere);
    if (Courant==null)
      return(false);
    Item=Courant.Fils;
  }
  
  if (Pere==null)
  {
    this.Nb_items++;
    Nb=this.Nb_items;
  }
  else
  {
    Courant.Nb_items++;
    Nb=Courant.Nb_items;
  }
    
  Item[Nb]=new AL_Definir_item_menu(this.Nom,this.Repertoire,this.Mode,
                                      Code,Longueur,Hauteur,Intitule,
                                      this.Evt,this.Icone,this.Interieur);
  return(true);
}

function AL_Rechercher_item_menu(Code,Item)
{
  var Trouve=null;
  
  if (Item==null) Item=this.Item;
  
  for (var i in Item)
  {
    var Courant=Item[i];

    if (Courant!="length")
    {
      if (Courant.Code==Code) 
        return(Courant);

      Trouve=this.Rechercher(Code,Courant.Fils);
      if (Trouve!=null)
        return(Trouve);
    }
  }

  return(null);
}

/* ouverture d'un menu ou d'un sous-menu */

function AL_Ouvrir_item_mode(Code,Item,Un_seul)
{
  var Retour=false;
  
  for (var i in Item)
  {
    var Courant=Item[i];

    if (Courant!="length")
    {
      if (Un_seul) Courant.Ouvert=false;
      if (Courant.Code==Code)
      {
        Courant.Ouvert=true;
        Retour=true;
      }

      if (AL_Ouvrir_item_mode(Code,Courant.Fils,Un_seul))
      {
        Courant.Ouvert=true;
        Retour=true;
      }
    }
  }

  return(Retour);
}

/* un seul item ouvert simultanment */

function AL_Ouvrir_item_mode_0(Code,Item)
{
  AL_Ouvrir_item_mode(Code,this.Item,true);
  this.Afficher();
  return;
}

function AL_Lire_hauteur_menu_mode_0(Item)
{
  var y=0,maxy=0,j=0;

  if (Item==null)
  {
    for (var i in this.Item)
    {
      var Courant=this.Item[i];
      if (Courant=="length") continue;
      j+=Courant.Hauteur;
      y=this.Lire_hauteur(Courant.Fils);
      if (y>maxy) maxy=y;
    }
    return(j+maxy);
  }

  for (var i in Item)
  {
    var Courant=Item[i];

    if (Courant=="length") continue;
    y+=Courant.Hauteur+this.Lire_hauteur(Courant.Fils);
  }

  return(y);
}

/* plusieurs items ouverts possibles */

function AL_Ouvrir_item_mode_1(Code,Item)
{
  AL_Ouvrir_item_mode(Code,this.Item,false);
  this.Afficher();
  return;
}

function AL_Lire_hauteur_menu_mode_1(Item)
{
  var y=0;
  
  if (Item==null) Item=this.Item;
  
  for (var i in Item)
  {
    var Courant=Item[i];

    if (Courant=="length") continue;
    y+=Courant.Hauteur+this.Lire_hauteur(Courant.Fils);
  }

  return(y);
}

function AL_Lire_hauteur_menu_mode_horizontal(Item)
{
  var maxy=0,h=0,y=0;

  if (Item==null)
  {
    Item=this.Item;
    for (var i in Item)
    {
      var Courant=Item[i];

      if (Courant=="length") continue;
      y=Courant.Hauteur+this.Lire_hauteur(Courant.Fils);
      if (maxy<y) maxy=y;
    }

    return(maxy);
  }

  for (var i in Item)
  {
    var Courant=Item[i];
    if (Courant=="length") continue;

    h=this.Lire_hauteur(Courant.Fils);
    if (h<Courant.Hauteur) h=Courant.Hauteur;
    h+=y;
    if (maxy<h) maxy=h;
    y+=Courant.Hauteur;
  }

  if (maxy<y) maxy=y;
  return(maxy);
}

function AL_Afficher_menu_vertical(x,y,Item,Visible)
{
  var i;
  
  if (x==null) x=this.x;
  if (y==null) y=this.y;
  
  if (Item==null) Item=this.Item;
  if (Visible==null) Visible=true;

  for (var i in Item)
  {
    var Courant=Item[i];

    if (Courant=="length") continue;
    
    if ((!Visible)&&(Courant.Nom_icone_visible!=null))
      Courant.Effacer();
    else if (Visible)
    {
      Courant.Afficher(x,y);
      y+=Courant.Hauteur;
    }
      
    y=this.Afficher(x+this.Decalage,y,Courant.Fils,(Visible)&&(Courant.Ouvert));
  }

  return(y);
}

function AL_Afficher_menu_horizontal(x,y,Item,Visible)
{
  var i;
  var offset;
  
  if (x==null) x=this.x;
  if (y==null) y=this.y;
  if (Visible==null) Visible=true;
  
  if (Item==null)
  {
    Item=this.Item;
    for (var i in Item)
    {
      var Courant=Item[i];

      if (Courant=="length") continue;

      if ((!Visible)&&(Courant.Nom_icone_visible!=null))
        Courant.Effacer();
      else if (Visible)
      {
        Courant.Afficher(x,y);
        if ((this.Icone)&&(!this.Interieur)) x+=15;
      }

      this.Afficher(x,y+Courant.Hauteur,Courant.Fils,Courant.Ouvert,true);

      if (Visible)
        x+=Courant.Longueur;
    }
    
    return(y);
  }

  for (var i in Item)
  {
    var Courant=Item[i];

    if (Courant=="length") continue;

    if ((!Visible)&&(Courant.Nom_icone_visible!=null))
      Courant.Effacer();
    else if (Visible)
      Courant.Afficher(x,y,true);

    if ((this.Icone)&&(!this.Interieur))
      this.Afficher(x+Courant.Longueur+15,y,Courant.Fils,(Visible)&&(Courant.Ouvert));
    else
      this.Afficher(x+Courant.Longueur,y,Courant.Fils,(Visible)&&(Courant.Ouvert));

    if (Visible)
      y+=Courant.Hauteur;
  }

  return(y);
}

function AL_Fermer_menu(Code)
{
  var Item=this.Rechercher(Code);

  if (Item==null)
    return;

  Item.Ouvert=false;
  this.Afficher();

  return;
}

function AL_Fermer_tout_menu(Item)
{
  if (Item==null) Item=this.Item;
  
  for (var i in Item)
  {
    var Courant=Item[i];
    if (Courant=="length") continue;
    Courant.Ouvert=false;
    this.Fermer_tout(Courant.Fils);
  }
  
  this.Afficher();
  return;
}

function AL_Lire_largeur_menu(Item,Profondeur)
{
  var x=0,max=0;

  if (Item==null) Item=this.Item;
  if (Profondeur==null) Profondeur=0;
  
  for (var i in Item)
  {
    var Courant=Item[i];

    if (Courant=="length") continue;

    x=Profondeur+Courant.Longueur;
    if ((this.Icone)&&(!this.Interieur)) x+=15;
    if (max<x) max=x;
    
    x=this.Lire_largeur(Courant.Fils,Profondeur+this.Decalage);
    if (max<x) max=x;
  }

  return(max);
}

function AL_Lire_largeur_menu_mode_horizontal(Item)
{
  var maxx=0,l=0,x=0;

  if (Item==null)
  {
    Item=this.Item;
    for (var i in Item)
    {
      var Courant=Item[i];
      if (Courant=="length") continue;

      l=this.Lire_largeur(Courant.Fils);
      if (l<Courant.Longueur) l=Courant.Longueur;
      l+=x;
      if ((this.Icone)&&(!this.Interieur)) { l+=15; x+=15; }
      if (maxx<l) maxx=l;
      x+=Courant.Longueur;
    }
    if (maxx<x) maxx=x;

    return(maxx);
  }

  for (var i in Item)
  {
    var Courant=Item[i];

    if (Courant=="length") continue;
    x=Courant.Longueur+this.Lire_largeur(Courant.Fils);
    if ((this.Icone)&&(!this.Interieur)) x+=15;
    if (maxx<x) maxx=x;
  }

  return(maxx);
}

function AL_Tracer_menu(Profondeur,Item)
{
  if (Profondeur==null)
  {
    Trace.Ecrire('Position de '+this.Nom+' ('+this.x+','+this.y+')-('+this.Lire_largeur()+','+this.Lire_hauteur()+')<br>');
    Trace.Ecrire('Mode : '+this.Mode+'<br>');
    Profondeur=0;
    Item=this.Item;
  }

  for (var i in Item)
  {
    var Courant=Item[i];

    if (Courant=="length") continue;

    for (var i=0;i<Profondeur;i++)
      Trace.Ecrire('&nbsp;');

    if (Courant.Nb_items==0)
      Trace.Ecrire('[*] ');
    else if (Courant.Ouvert) 
      Trace.Ecrire('[-] '); 
    else 
      Trace.Ecrire('[+] ');

    Trace.Ecrire(Courant.Code+' - <pre>'+Courant.Intitule+'</pre><br>');
    this.Tracer(Profondeur+1,Courant.Fils);
  }
}

function AL_Creer_menu(Nom,Repertoire,x,y,Decalage,Mode)
{
  this.Nom=Nom;
  this.x=x;
  this.y=y;
  this.Decalage=Decalage;
  this.Nb_items=0;
  this.Repertoire=Repertoire;
  this.Horizontal=((Mode&AL_Menu_mode_horizontal)!=0);
  this.Interieur=((Mode&AL_Menu_mode_interieur)!=0);
  if ((this.Repertoire==null)||(Mode&AL_Menu_mode_sans_icone))
    Mode=AL_Menu_mode_seul+AL_Menu_mode_survol+AL_Menu_mode_sans_icone;
  if (this.Horizontal) Mode+=AL_Menu_mode_horizontal;
  if (this.Interieur) Mode+=AL_Menu_mode_interieur;
  this.Icone=((Mode&AL_Menu_mode_sans_icone)==0);
  this.Item=new Array();
  this.Mode=Mode;

  this.Evt="onClick";
  if (Mode&AL_Menu_mode_survol)
    this.Evt="onMouseOver";

  this.Creer=AL_Creer_item_menu;
  this.Rechercher=AL_Rechercher_item_menu;
  this.Fermer=AL_Fermer_menu;
  this.Fermer_tout=AL_Fermer_tout_menu;

  if ((Mode&1)==AL_Menu_mode_seul)
  {
    this.Ouvrir=AL_Ouvrir_item_mode_0;
    this.Lire_hauteur=AL_Lire_hauteur_menu_mode_0;
  }
  else
  {
    this.Ouvrir=AL_Ouvrir_item_mode_1;
    this.Lire_hauteur=AL_Lire_hauteur_menu_mode_1;
  }
  
  if (this.Horizontal)
  {
    this.Afficher=AL_Afficher_menu_horizontal;
    this.Lire_hauteur=AL_Lire_hauteur_menu_mode_horizontal;
    this.Lire_largeur=AL_Lire_largeur_menu_mode_horizontal;
  }
  else
  {
    this.Afficher=AL_Afficher_menu_vertical;
    this.Lire_largeur=AL_Lire_largeur_menu;
  }

  this.Tracer=AL_Tracer_menu;
  
  return(this);
}